精华内容
下载资源
问答
  • python如何写try语句

    2020-12-17 06:53:01
    pythontry语句有两种风格 一是处理异常(try/except/else) 二是无论是否发生异常都将执行最后的代码(try/finally) try/except/else风格 try:  <语句> #运行的代码 except <名字>:  <语句> #...
  • 一.什么是异常 我们需要明白的是异常的发生不是因为我们代码写错了,我们的代码是可以编译的,但是在运行时产生了一个错误,这个错误是一个异常情况,计算机不能处理这个...第二种方法:使用try语句处理异常,事实上
  • python的错误处理——try语句

    千次阅读 2021-02-05 09:05:53
    python的错误处理——try语句最近开始整理python的资料,博主建立了一个qq群,希望给大家提供一个交流的同平台:78486745 。当我们认为某些代码可能会出错时,就可以用try来运行这段代码,如果执行出错,则后续代码...

    python的错误处理——try语句

    最近开始整理python的资料,博主建立了一个qq群,希望给大家提供一个交流的同平台:78486745 。

    当我们认为某些代码可能会出错时,就可以用try来运行这段代码,如果执行出错,则后续代码不会继续执行,而是直接跳转至错误处理代码,即except语句块,执行完except后,如果有finally语句块,则执行finally语句块,至此,执行完毕。

    python的try语句有两种风格

    处理异常(try/except/else)

    种是无论是否发生异常都将执行最后的代码(try/finally)

    try/except/else风格

    try:

    #运行别的代码

    except :

    #如果在try部份引发了'name'异常

    except ,:

    #如果引发了'name'异常,获得附加的数据

    else:

    #如果没有异常发生

    try的工作原理是,当开始一个try语句后,python就在当前程序的上下文中作标记,这样当异常出现时就可以回到这里,try子句先执行,接下来会发生什么依赖于执行时是否出现异常。

    1、如果当try后的语句执行时发生异常,python就跳回到try并执行第一个匹配该异常的except子句,异常处理完毕,控制流就通过整个try语句(除非在处理异常时又引发新的异常)。

    2、如果在try后的语句里发生了异常,却没有匹配的except子句,异常将被递交到上层的try,或者到程序的最上层(这样将结束程序,并打印缺省的出错信息)。

    3、如果在try子句执行时没有发生异常,python将执行else语句后的语句(如果有else的话),然后控制流通过整个try语句。

    try/finally风格

    try:

    finally:

    #退出try时总会执行finally语句

    python总会执行finally子句,无论try子句执行时是否发一异常。

    1、如果没有发生异常,python运行try子句,然后是finally子句,然后继续。

    2、如果在try子句发生了异常,python就会回来执行finally子句,然后把异常递交给上层try,控制流不会通过整个try语句。

    当你想无论是否发生异常都确保执行某些代码时,try/finally是有用的。

    这个在打开文件的时候有用 finally总是在最后close()文件

    try语句子句形式表

    except: 捕获所有异常

    except name: 只捕获特定的异常

    except name,value: 捕获异常和它的附加数据(将异常的信息保存到value,)

    except (name1,name2): 捕获任何列出的异常

    else: 如果没有异常

    finally: 总是执行

    try:

    f = open('file.txt')

    except IOError as e:

    print e

    else:

    print 'wrong'

    [Errno 2] No such file or directory: 'file.txt'

    try/except/finally:

    #1:如果x没有异常,执行z,i

    #2:如果x有异常,

    #一:如果except捕捉到异常则执行y,i

    #二:没捕捉到,执行i,然后返回内置异常处理

    try:

    x

    except(name):

    y

    else:

    z

    finally:

    i

    展开全文
  • Pythontry语句的用法

    万次阅读 多人点赞 2016-04-17 21:13:43
    1. try except语句的用法,用来检测一段代码内出现的异常并将其归类输出相关信息,首先是try: 被检测代码段 except Exception[as reason]: 相关信息,举例说明: >>> try:  f = open('该文档不存在')  print...
    1. try except语句的用法,用来检测一段代码内出现的异常并将其归类输出相关信息,首先是try: 被检测代码段  except Exception[as reason]: 相关信息,举例说明:
    
    >>> try:
        f = open('该文档不存在')
        print(f.read())
        f.close()
    except OSError:
        print('文件出错了T_T')    

    文件出错了T_T
             当然,我们也可以在except Exception 加上 as reason将程序检测到的出错的信息输出,举例说明:
    try:
        f = open('该文档不存在')
        print(f.read())
        f.close()
    except OSError as reason:
        print('文件出错了T_T')
        print('出错原因是%s'%str(reason))

    文件出错了T_T
    出错原因是[Errno 2] No such file or directory: '该文档不存在'
             当然,可以增加多个except语句,提取代码段不同的异常问题,举例说明:
    try:
        1 + '1'
        f = open('该文档不存在')
        print(f.read())
        f.close()
    except OSError as reason:
        print('文件出错了T_T')
        print('出错原因是%s'%str(reason))
    except TypeError as reason:
        print('求和出错了T_T')
        print('出错原因是%s'%str(reason))

    求和出错了T_T
    出错原因是unsupported operand type(s) for +: 'int' and 'str'
             但是需要注意程序检测到第一个异常后即停止运行,在except中找到相应输出语句,如果except未包含时,则直接曝出异常,
    try:
        fishc
        1 + '1'
        f = open('该文档不存在')
        print(f.read())
        f.close()
    except OSError as reason:
        print('文件出错了T_T')
        print('出错原因是%s'%str(reason))
    except TypeError as reason:
        print('求和出错了T_T')
        print('出错原因是%s'%str(reason))

    Traceback (most recent call last):
      File "D:/Python34/test/033/01.py", line 2, in <module>
        fishc
    NameError: name 'fishc' is not defined

             另外,可以将Exception信息放在一个except语句下面,举例说明:
    try:
        fishc
        1 + '1'
        f = open('该文档不存在')
        print(f.read())
        f.close()
    except (OSError,TypeError,NameError) as reason:
        print('出错了T_T')
        print('出错原因是%s'%str(reason))
    出错了T_T
    出错原因是name 'fishc' is not defined
             甚至except语句连Except都不要了,则程序检测到异常就会执行except下的语句,但不推荐使用:
    try:
        fishc
        1 + '1'
        f = open('该文档不存在')
        print(f.read())
        f.close()
    except:
        print('出错了T_T')

    出错了T_T

    2. try finally语句,一般是在try except语句下面补充,用于程序检测到异常后仍能执行的语句:
    try:
        fishc
        1 + '1'
        f = open('新文档.txt',wt)
    except (OSError,TypeError,NameError) as reason:
        print('出错了T_T')
        print('出错原因是%s'%str(reason))
    finally:
        f = open('新文档.txt','wt')
        f.write('我爱鱼C论坛!')
        f.close()
        f = open('新文档.txt','rt')
        print(f.read())
        f.close()

    出错了T_T
    出错原因是name 'fishc' is not defined
    我爱鱼C论坛!
    3. raise语句,raise Exception,引入一个异常,举例说明:
    >>> raise NameError
    Traceback (most recent call last):
      File "<pyshell#12>", line 1, in <module>
        raise NameError
    NameError

    >>> raise ZeroDivisionError('除数是0')
    Traceback (most recent call last):
      File "<pyshell#14>", line 1, in <module>
        raise ZeroDivisionError('除数是0')
    ZeroDivisionError: 除数是0
    展开全文
  • python的异常,以及用try复合语句处理异常。 运行代码时有时会出现各种各样的错误,致使解析器中断执行,并提示xxxxxxErorr的提示,后面跟具体的错误的描述,这被称为是引发了异常。 其实异常告诉我们的是遇到了什么...
  • 当我们认为某些代码可能会出错时,就可以用try来运行这段代码,如果执行出错,则后续代码...pythontry语句有两种风格 处理异常(try/except/else) 种是无论是否发生异常都将执行最后的代码(try/finally) tr...

    当我们认为某些代码可能会出错时,就可以用try来运行这段代码,如果执行出错,则后续代码不会继续执行,而是直接跳转至错误处理代码,即except语句块,执行完except后,如果有finally语句块,则执行finally语句块,至此,执行完毕。

    python的try语句有两种风格

    1. 处理异常(try/except/else)
    2. 种是无论是否发生异常都将执行最后的代码(try/finally)

    try/except/else风格

    try:
        <语句> #运行别的代码
    except <名字>: 
        <语句> #如果在try部份引发了'name'异常
    except <名字>,<数据>:
        <语句> #如果引发了'name'异常,获得附加的数据
    else:
        <语句> #如果没有异常发生
    

    try的工作原理是,当开始一个try语句后,python就在当前程序的上下文中作标记,这样当异常出现时就可以回到这里,try子句先执行,接下来会发生什么依赖于执行时是否出现异常。
    1、如果当try后的语句执行时发生异常,python就跳回到try并执行第一个匹配该异常的except子句,异常处理完毕,控制流就通过整个try语句(除非在处理异常时又引发新的异常)。
    2、如果在try后的语句里发生了异常,却没有匹配的except子句,异常将被递交到上层的try,或者到程序的最上层(这样将结束程序,并打印缺省的出错信息)。
    3、如果在try子句执行时没有发生异常,python将执行else语句后的语句(如果有else的话),然后控制流通过整个try语句。

    try/finally风格

    try:
        <语句>
    finally:
        <语句> #退出try时总会执行finally语句
    

    python总会执行finally子句,无论try子句执行时是否发一异常。
    1、如果没有发生异常,python运行try子句,然后是finally子句,然后继续。
    2、如果在try子句发生了异常,python就会回来执行finally子句,然后把异常递交给上层try,控制流不会通过整个try语句

    当你想无论是否发生异常都确保执行某些代码时,try/finally是有用的。

    这个在打开文件的时候有用 finally总是在最后close()文件

    try语句子句形式表
    except: 捕获所有异常
    except name: 只捕获特定的异常
    except name,value: 捕获异常和它的附加数据(将异常的信息保存到value,)
    except (name1,name2): 捕获任何列出的异常
    else: 如果没有异常
    finally: 总是执行

    try:
       f = open('file.txt')
    except IOError as e:
       print e
    else:
       print 'wrong'
    
    [Errno 2] No such file or directory: 'file.txt'
    

    try/except/finally:

    #1:如果x没有异常,执行z,i
    #2:如果x有异常, 
    #一:如果except捕捉到异常则执行y,i
    #二:没捕捉到,执行i,然后返回内置异常处理 
    
    try: 
        x 
    except(name): 
        y
    else:
        z
    finally:
        i
    

    最近开始整理python的资料,博主建立了一个qq群,希望给大家提供一个交流的同平台:78486745 。在这里插入图片描述

    展开全文
  • Python学习笔记 欢迎使用Markdown编辑器 你好! 这是你第一次使用 Markdown编辑器 所展示的欢迎页。如果你想学习如何使用Markdown编辑器, 可以仔细阅读这篇文章,了解一下Markdown的基本语法知识。 新的改变 我们对...

    try:

    f = open(‘test.txt’)

    print(f.read())

    f.close()

    except OSError as error:

    print(‘打开文件出错\n原因是:’+str(error))

    “”“try 下面的子句要是没有出错不会去执行except 发现异常则会执行except后面的语句”""

    try:

    int(“abc”)

    s = 1+ ‘1’

    f = open(‘test.txt’)

    print(f.read())

    f.close()

    except OSError as error:

    print(‘打开文件出错\n原因是:’ + str(error))

    except TypeError as error:

    print(‘类型出错\n原因是:’ + str(error))

    except ValueError as error:

    print(‘数值出错\n原因是:’ + str(error)

    “”“一个try可以对应多个except 但是只有一个except会被执行”""

    dict1 = {‘a’: 1, ‘b’: 2, ‘v’: 22}

    try:

    x = dict1[‘y’]

    except LookupError:

    print(‘查询错误!’)

    except KeyError:

    print(‘键错误!’)

    else:

    print(x)

    try:
    s = 1 + ‘1’
    int(‘abc’)
    f = open(‘tet.txt’)
    print(f.read())
    f.close()
    except (OSError,TypeError,ValueError) as error:
    print(‘出错了\n原因是:’ + str(error))

    def divide(x,y):
    try:
    result = x/y
    print('result is ', result)
    except ZeroDivisionError:
    print(‘division by zero!’)
    finally:
    print(‘excuting finally clause’)

    print(divide(2,1)

    print(divide(2,0))

    print(divide(“2”,“1”))

    展开全文
  • 在我的应用程序中,我从文件...Python:如何在异常停止后继续执行try语句我正在做这样的:try:data_A = getDefaultConf(param_1,param_2)except Exception as e:log(WARNING, "Failed to get default parametres: "...
  • python的“异常”处理——try语句

    千次阅读 2019-03-06 21:32:04
    最近开始整理python的资料,博主建立了一个qq群,希望给大家提供一个交流的同平台:78486745 。 当我们认为某些代码可能会出错时,就可以用try来运行这段代码,如果执行出错,则...pythontry语句有两种风格 处理...
  • 直接执行耗时操作和耗时操作放在try中执行并无异常触发时性能消耗几乎是一样的。 无论是把要计算的代码放在 try 中执行还是在 except 中执行性能消耗几乎是一样的。
  • try/except与其他语言相同,在python中,try/except语句主要是用于throw程序正常执行过程中出现的异常,如语法错(python作为脚本语言没有编译的环节,在执行过程中对语法进行检测,出错后发出异常消息)、数据除零...
  • python try语句相关(try/except/else/finally)

    万次阅读 多人点赞 2018-05-09 22:11:19
    1、try - except 作用: 捕获程序在执行时遇到的异常情况,即一些报错。什么啥玩意儿没定义啊,符号又错了啊之类的你懂得。 意义: 因为程序在发现某个错误时,往往会中断不再向下执行,如下例子说明问题: 很...
  • python常见的错误处理——try语句

    千次阅读 2019-01-23 21:21:31
    python的错误处理——try语句 最近开始整理python的资料,博主建立了一个qq群,希望给大家提供一个交流的同平台:78486745 。 当我们认为某些代码可能会出错时,就可以用try来运行这段代码,如果执行出错,则后续...
  • 【填空题】901x28=【判断题】在Python中,类中定义的类的成员(属性)或类方法,默认情况下都为公有的。【单选题】Outlines can be derived most easily from __________.【单选题】美国鸟类学基金会在不久前公布了...
  • 我的Python在学习这个。在有一个脚本连接到从文件中提供的地址...它所做的是将父try语句继续到最后,这是毫无意义的,因为脚本无论如何都无法连接:for ip in ips:try:try:#print curent addressprint "Connecting ...
  • try语句一般都搭配except and finnaly使用。这样是为了给自己的程序留一个后手,如果出现了对应设置的Error,可以“暗度陈仓”,然后必要的时候辅助finnaly来一个强制执行。一个try是可以跟多个except的,毕竟一个...
  • xiaobaitu7788 python中的try的用法 2019-09-04try语句python里面的控制语句,与except,finally配合使用处理在程序运行中chu现的异常情况。 try的工作原理是:当开始一个try语句后,python就在当前程序的...anonymous...
  • try/except介绍与其他语言相同,在python中,try/except语句主要是用于处理程序正常执行过程中出现的一些异常情况,如语法错(python作为脚本语言没有编译的环节,在执行过程中对语法进行检测,出错后发出异常消息)...
  • 打印当前.py文件错误行:import systry:a = [1,2]print a[3]except:s=sys.exc_info()print "Error '%s' happened on line %d" % (s[1],s[2].tb_lineno)打印execfile的打印错误行:try:execfile("tprint.py")except ...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 96,803
精华内容 38,721
关键字:

try语句python

python 订阅